Index: main/tcptls.c
===================================================================
--- main/tcptls.c	(revision 374904)
+++ main/tcptls.c	(working copy)
@@ -191,20 +191,31 @@
 				X509 *peer;
 				long res;
 				peer = SSL_get_peer_certificate(tcptls_session->ssl);
-				if (!peer) {
-					ast_log(LOG_WARNING, "No peer SSL certificate\n");
-				}
 				res = SSL_get_verify_result(tcptls_session->ssl);
 				if (res != X509_V_OK) {
 					ast_log(LOG_ERROR, "Certificate did not verify: %s\n", X509_verify_cert_error_string(res));
+					if (peer) {
+						X509_free(peer);
+					}
+					ast_tcptls_close_session_file(tcptls_session);
+					ao2_ref(tcptls_session, -1);
+					return NULL;
 				}
 				if (!ast_test_flag(&tcptls_session->parent->tls_cfg->flags, AST_SSL_IGNORE_COMMON_NAME)) {
 					ASN1_STRING *str;
 					unsigned char *str2;
-					X509_NAME *name = X509_get_subject_name(peer);
+					X509_NAME *name;
 					int pos = -1;
 					int found = 0;
 
+					if (!peer) {
+						ast_log(LOG_ERROR, "No peer SSL certificate to check common name\n");
+						ast_tcptls_close_session_file(tcptls_session);
+						ao2_ref(tcptls_session, -1);
+						return NULL;
+					}
+					name = X509_get_subject_name(peer);
+
 					for (;;) {
 						/* Walk the certificate to check all available "Common Name" */
 						/* XXX Probably should do a gethostbyname on the hostname and compare that as well */
